#        Copyright 2011 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       This file is part of zenpakt

#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

$$

#Rounds up the given size in bytes to human readable values as accurately as
#bashly possible, ie, not very accurate
size_b2h() {
  local _size_b2h
  if (($1 >= 1073741824)); then
    printf -v _size_b2h '%.0fG' $(($1/1073741824)).$(($1%1073741824))
  elif (($1 >= 1048576)) ; then
    printf -v _size_b2h '%.0fM' $(($1/1048576)).$(($1%1048576))
  elif (($1 >=  1024 )) ; then
    printf -v _size_b2h '%.0fK' $(($1/1024)).$(($1%1024))
  else
    _size_b2h=$1B
  fi

  if [[ $2 ]] ; then
    printf -v "$2" '%s' "$_size_b2h"
  else
    printf '%s\n' "$_size_b2h"
  fi
}
